{ķ}
{                       KEYBOARD TEST Version 1.0                          }
{                  Copyright (C) 1997 by The GodFather                     }
{ͼ}

{$M 1024,16384,16384}
USES Dos,
     GUtils;

CONST
  Version = 'Version 1.0';

TYPE
  TKey = RECORD
    KeyCode : Byte;
    Pressed : Boolean;
    XPos    : Byte;
    YPos    : Byte;
    Name    : STRING[6];
  END;


CONST
  X = 3;
  Y = 6;


CONST
  Keys: ARRAY[1..127] OF TKey =
{ESC}((KeyCode:$01; Pressed:False; XPos:X+01; YPos:Y+01; Name:'ESC'),
{ 1  }(KeyCode:$02; Pressed:False; XPos:X+04; YPos:Y+05; Name:'1'),
{ 2  }(KeyCode:$03; Pressed:False; XPos:X+07; YPos:Y+05; Name:'2'),
{ 3  }(KeyCode:$04; Pressed:False; XPos:X+10; YPos:Y+05; Name:'3'),
{ 4  }(KeyCode:$05; Pressed:False; XPos:X+13; YPos:Y+05; Name:'4'),
{ 5  }(KeyCode:$06; Pressed:False; XPos:X+16; YPos:Y+05; Name:'5'),
{ 6  }(KeyCode:$07; Pressed:False; XPos:X+19; YPos:Y+05; Name:'6'),
{ 7  }(KeyCode:$08; Pressed:False; XPos:X+22; YPos:Y+05; Name:'7'),
{ 8  }(KeyCode:$09; Pressed:False; XPos:X+25; YPos:Y+05; Name:'8'),
{ 9  }(KeyCode:$0A; Pressed:False; XPos:X+28; YPos:Y+05; Name:'9'),
{ 0  }(KeyCode:$0B; Pressed:False; XPos:X+31; YPos:Y+05; Name:'0'),
{ -  }(KeyCode:$0C; Pressed:False; XPos:X+34; YPos:Y+05; Name:'-'),
{ =  }(KeyCode:$0D; Pressed:False; XPos:X+37; YPos:Y+05; Name:'='),
{BSp }(KeyCode:$0E; Pressed:False; XPos:X+43; YPos:Y+05; Name:''),
{TAB }(KeyCode:$0F; Pressed:False; XPos:X+01; YPos:Y+08; Name:'TAB'),
{ Q  }(KeyCode:$10; Pressed:False; XPos:X+06; YPos:Y+08; Name:'Q'),
{ W  }(KeyCode:$11; Pressed:False; XPos:X+09; YPos:Y+08; Name:'W'),
{ E  }(KeyCode:$12; Pressed:False; XPos:X+12; YPos:Y+08; Name:'E'),
{ R  }(KeyCode:$13; Pressed:False; XPos:X+15; YPos:Y+08; Name:'R'),
{ T  }(KeyCode:$14; Pressed:False; XPos:X+18; YPos:Y+08; Name:'T'),
{ Y  }(KeyCode:$15; Pressed:False; XPos:X+21; YPos:Y+08; Name:'Y'),
{ U  }(KeyCode:$16; Pressed:False; XPos:X+24; YPos:Y+08; Name:'U'),
{ I  }(KeyCode:$17; Pressed:False; XPos:X+27; YPos:Y+08; Name:'I'),
{ O  }(KeyCode:$18; Pressed:False; XPos:X+30; YPos:Y+08; Name:'O'),
{ P  }(KeyCode:$19; Pressed:False; XPos:X+33; YPos:Y+08; Name:'P'),
{ [  }(KeyCode:$1A; Pressed:False; XPos:X+36; YPos:Y+08; Name:'['),
{ ]  }(KeyCode:$1B; Pressed:False; XPos:X+39; YPos:Y+08; Name:']'),
{ENT }(KeyCode:$1C; Pressed:False; XPos:X+40; YPos:Y+11; Name:'ENTER'),
{CTRL}(KeyCode:$1D; Pressed:False; XPos:X+01; YPos:Y+17; Name:'CTRL'),
{ A  }(KeyCode:$1E; Pressed:False; XPos:X+07; YPos:Y+11; Name:'A'),
{ S  }(KeyCode:$1F; Pressed:False; XPos:X+10; YPos:Y+11; Name:'S'),
{ D  }(KeyCode:$20; Pressed:False; XPos:X+13; YPos:Y+11; Name:'D'),
{ F  }(KeyCode:$21; Pressed:False; XPos:X+16; YPos:Y+11; Name:'F'),
{ G  }(KeyCode:$22; Pressed:False; XPos:X+19; YPos:Y+11; Name:'G'),
{ H  }(KeyCode:$23; Pressed:False; XPos:X+22; YPos:Y+11; Name:'H'),
{ J  }(KeyCode:$24; Pressed:False; XPos:X+25; YPos:Y+11; Name:'J'),
{ K  }(KeyCode:$25; Pressed:False; XPos:X+28; YPos:Y+11; Name:'K'),
{ L  }(KeyCode:$26; Pressed:False; XPos:X+31; YPos:Y+11; Name:'L'),
{ ;  }(KeyCode:$27; Pressed:False; XPos:X+34; YPos:Y+11; Name:';'),
{ '  }(KeyCode:$28; Pressed:False; XPos:X+37; YPos:Y+11; Name:''''),
{ `  }(KeyCode:$29; Pressed:False; XPos:X+01; YPos:Y+05; Name:'`'),
{LSh }(KeyCode:$2A; Pressed:False; XPos:X+01; YPos:Y+14; Name:'LSHIFT'),
{ \  }(KeyCode:$2B; Pressed:False; XPos:X+40; YPos:Y+05; Name:'\'),
{ Z  }(KeyCode:$2C; Pressed:False; XPos:X+09; YPos:Y+14; Name:'Z'),
{ X  }(KeyCode:$2D; Pressed:False; XPos:X+12; YPos:Y+14; Name:'X'),
{ C  }(KeyCode:$2E; Pressed:False; XPos:X+15; YPos:Y+14; Name:'C'),
{ V  }(KeyCode:$2F; Pressed:False; XPos:X+18; YPos:Y+14; Name:'V'),
{ B  }(KeyCode:$30; Pressed:False; XPos:X+21; YPos:Y+14; Name:'B'),
{ N  }(KeyCode:$31; Pressed:False; XPos:X+24; YPos:Y+14; Name:'N'),
{ M  }(KeyCode:$32; Pressed:False; XPos:X+27; YPos:Y+14; Name:'M'),
{ ,  }(KeyCode:$33; Pressed:False; XPos:X+30; YPos:Y+14; Name:','),
{ .  }(KeyCode:$34; Pressed:False; XPos:X+33; YPos:Y+14; Name:'.'),
{ /  }(KeyCode:$35; Pressed:False; XPos:X+36; YPos:Y+14; Name:'/'),
{RSh }(KeyCode:$36; Pressed:False; XPos:X+39; YPos:Y+14; Name:'RSHIFT'),
{G * }(KeyCode:$37; Pressed:False; XPos:X+69; YPos:Y+05; Name:' *'),
{Alt }(KeyCode:$38; Pressed:False; XPos:X+07; YPos:Y+17; Name:'ALT'),
{SPC }(KeyCode:$39; Pressed:False; XPos:X+22; YPos:Y+17; Name:'SPACE'),
{CAP }(KeyCode:$3A; Pressed:False; XPos:X+01; YPos:Y+11; Name:'CAPS'),
{F1  }(KeyCode:$3B; Pressed:False; XPos:X+08; YPos:Y+01; Name:'F1'),
{F2  }(KeyCode:$3C; Pressed:False; XPos:X+11; YPos:Y+01; Name:'F2'),
{F3  }(KeyCode:$3D; Pressed:False; XPos:X+14; YPos:Y+01; Name:'F3'),
{F4  }(KeyCode:$3E; Pressed:False; XPos:X+17; YPos:Y+01; Name:'F4'),
{F5  }(KeyCode:$3F; Pressed:False; XPos:X+21; YPos:Y+01; Name:'F5'),
{F6  }(KeyCode:$40; Pressed:False; XPos:X+24; YPos:Y+01; Name:'F6'),
{F7  }(KeyCode:$41; Pressed:False; XPos:X+27; YPos:Y+01; Name:'F7'),
{F8  }(KeyCode:$42; Pressed:False; XPos:X+30; YPos:Y+01; Name:'F8'),
{F9  }(KeyCode:$43; Pressed:False; XPos:X+34; YPos:Y+01; Name:'F9'),
{F10 }(KeyCode:$44; Pressed:False; XPos:X+37; YPos:Y+01; Name:'10'),
{NL  }(KeyCode:$45; Pressed:False; XPos:X+61; YPos:Y+05; Name:'NL'),
{SL  }(KeyCode:$46; Pressed:False; XPos:X+52; YPos:Y+01; Name:'SL'),

{g 7 }(KeyCode:$47; Pressed:False; XPos:X+61; YPos:Y+08; Name:' 7'),
{g 8 }(KeyCode:$48; Pressed:False; XPos:X+65; YPos:Y+08; Name:' 8'),
{g 9 }(KeyCode:$49; Pressed:False; XPos:X+69; YPos:Y+08; Name:' 9'),
{g - }(KeyCode:$4A; Pressed:False; XPos:X+73; YPos:Y+05; Name:' -'),
{g 4 }(KeyCode:$4B; Pressed:False; XPos:X+61; YPos:Y+11; Name:' 4'),
{g 5 }(KeyCode:$4C; Pressed:False; XPos:X+65; YPos:Y+11; Name:' 5'),
{g 6 }(KeyCode:$4D; Pressed:False; XPos:X+69; YPos:Y+11; Name:' 6'),
{g + }(KeyCode:$4E; Pressed:False; XPos:X+73; YPos:Y+11; Name:' +'),
{g 1 }(KeyCode:$4F; Pressed:False; XPos:X+61; YPos:Y+14; Name:' 1'),
{g 2 }(KeyCode:$50; Pressed:False; XPos:X+65; YPos:Y+14; Name:' 2'),
{g 3 }(KeyCode:$51; Pressed:False; XPos:X+69; YPos:Y+14; Name:' 3'),
{g 0 }(KeyCode:$52; Pressed:False; XPos:X+61; YPos:Y+17; Name:' 0 '),
{g . }(KeyCode:$53; Pressed:False; XPos:X+69; YPos:Y+17; Name:' .'),
{    }(KeyCode:$54; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$55; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$56; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{F11 }(KeyCode:$57; Pressed:False; XPos:X+40; YPos:Y+01; Name:'11'),
{F12 }(KeyCode:$58; Pressed:False; XPos:X+43; YPos:Y+01; Name:'12'),


{g / }(KeyCode:$59; Pressed:False; XPos:X+65; YPos:Y+05; Name:' /'),
{RAlt}(KeyCode:$5A; Pressed:False; XPos:X+36; YPos:Y+17; Name:'ALT'),
{G En}(KeyCode:$5B; Pressed:False; XPos:X+73; YPos:Y+17; Name:#17#217),
{RCtr}(KeyCode:$5C; Pressed:False; XPos:X+41; YPos:Y+17; Name:'CTRL'),
{    }(KeyCode:$5D; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$5E; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$5F; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$60; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$61; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$62; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$63; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$64; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$65; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$66; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$67; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$68; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),

{Home}(KeyCode:$69; Pressed:False; XPos:X+52; YPos:Y+05; Name:'HO'),
{ Up }(KeyCode:$6A; Pressed:False; XPos:X+52; YPos:Y+14; Name:' '#24),
{PgUp}(KeyCode:$6B; Pressed:False; XPos:X+56; YPos:Y+05; Name:'PU'),
{    }(KeyCode:$6C; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{Left}(KeyCode:$6D; Pressed:False; XPos:X+48; YPos:Y+17; Name:' '#27),
{    }(KeyCode:$6E; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{Righ}(KeyCode:$6F; Pressed:False; XPos:X+56; YPos:Y+17; Name:' '#26),
{    }(KeyCode:$70; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{End }(KeyCode:$71; Pressed:False; XPos:X+52; YPos:Y+08; Name:'EN'),
{Down}(KeyCode:$72; Pressed:False; XPos:X+52; YPos:Y+17; Name:' '#25),
{PgDn}(KeyCode:$73; Pressed:False; XPos:X+56; YPos:Y+08; Name:'PD'),
{Ins }(KeyCode:$74; Pressed:False; XPos:X+48; YPos:Y+05; Name:'IN'),
{Del }(KeyCode:$75; Pressed:False; XPos:X+48; YPos:Y+08; Name:'DE'),
{    }(KeyCode:$76; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$77; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$78; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$79; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$7A; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$7B; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$7C; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$7D; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$7E; Pressed:False; XPos:X+01; YPos:Y+01; Name:''),
{    }(KeyCode:$7F; Pressed:False; XPos:X+01; YPos:Y+01; Name:''));


VAR
  Index      : Byte;
  Port60h    : Byte;
  Port61h    : Byte;
  OldInt09   : Pointer;
  KeyStatus  : Byte ABSOLUTE $40:$17;
  QuitCounter: Byte;

  Add        : Byte;
  Special    : Boolean;


 FUNCTION TestMF2:Boolean; ASSEMBLER;
 ASM
	MOV	AX, 1200h
	INT	16h
	CMP	AX, 1200h
	MOV	AL, True
	JNE	@Quit
	MOV	AL, False
  @Quit:
 END;


 PROCEDURE NewKBDint; INTERRUPT;
 LABEL Update,Quit;
 BEGIN
   Port60h := Port[$60];                              { Read key           }

   IF Special THEN GOTO Update;
   IF Port60h = $E0 THEN Special := True;
   IF Special THEN GOTO Quit;

 Update:
   IF Special
      THEN BEGIN
             Add := 34;
             CASE Port60h OF
               $1C, $1C+$80,                   { Gray ENTER }
               $1D, $1D+$80: Add := Add + $1D; { Right CTRL }
               $35, $35+$80: Add := Add + $02; { Gray /     }
             END;
             Keys[(Port60h AND $7F) + Add].Pressed := (Port60h <= $7F);
           END
      ELSE Keys[(Port60h AND $7F)].Pressed := (Port60h <= $7F);

   IF Port60h = $81 THEN Inc(QuitCounter);
   Special     := False;
 Quit:
   Port61h := Port[$61];                              { Read KBD status    }
   Port[$61] := Port61h OR $80;                       { Reset KBD          }
   Port[$61] := Port61h;                              { Restore KBD status }
   Port[$20] := $20;                                  { Send EOI           }
   KeyStatus := 0;                                    { Reset BIOS variable}
 END;


PROCEDURE ShowKBD;
VAR Attr:Byte;
BEGIN
  Attr := $5D;
  FastWrite(X+0,Y+00,Attr,'ķ  ķķķ ķķķ');
  FastWrite(X+0,Y+01,Attr,'ESC  F1F2F3F4F5F6F7F8F9101112 PSSLPA');
  FastWrite(X+0,Y+02,Attr,'ͼ  ͼͼͼ ͼͼͼ');
  FastWrite(X+0,Y+04,Attr,'ķķķķķķķķķķķķķķķ ķķķ ķķķķ');
  FastWrite(X+0,Y+05,Attr,'`1234567890-=\- INHOPU NL / * -');
  FastWrite(X+0,Y+06,Attr,'ͼͼͼͼͼͼͼͼͼͼͼͼͼͼͼ ͼͼͼ ͼͼͼͼ');
  FastWrite(X+0,Y+07,Attr,'ķķķķķķķķķķķķķķ ķķķ ķķķķ');
  FastWrite(X+0,Y+08,Attr,'TABQWERTYUIOP[]    DEENPD  7 8 9  ');
  FastWrite(X+0,Y+09,Attr,'ͼͼͼͼͼͼͼͼͼͼͼͼͼ    ͼͼͼ ͼͼͼ  ');
  FastWrite(X+0,Y+10,Attr,'ķķķķķķķķķķķķ                 ķķķ  ');
  FastWrite(X+0,Y+11,Attr,'CAPSASDFGHJKL;''ENTER               4 5 6 +');
  FastWrite(X+0,Y+12,Attr,'ͼͼͼͼͼͼͼͼͼͼͼͼͼ              ͼͼͼͼ');
  FastWrite(X+0,Y+13,Attr,'ķķķķķķķķķķķķ     ķ     ķķķķ');
  FastWrite(X+0,Y+14,Attr,'LSHIFTZXCVBNM,./RSHIFT            1 2 3  ');
  FastWrite(X+0,Y+15,Attr,'ͼͼͼͼͼͼͼͼͼͼͼͼ     ͼ     ͼͼͼ  ');
  FastWrite(X+0,Y+16,Attr,'ķķķķķ ķķķ ķķ  ');
  FastWrite(X+0,Y+17,Attr,'CTRLALT          SPACE       ALTCTRL   '#26'   0     .ٺ');
  FastWrite(X+0,Y+18,Attr,'ͼͼͼͼͼ ͼͼͼ ͼͼͼ');
END;


PROCEDURE ShowKey(CONST Key:TKey);
VAR Attr:Byte;
BEGIN
  WITH Key DO
  BEGIN
    IF Pressed
      THEN Attr := $F0
      ELSE Attr := $57;
    FastWrite(XPos,YPos,Attr,Name);
  END;
END;




{ =========================== }
{ ============ MAIN ========= }
{ =========================== }
BEGIN
  IF NOT TestMF2 THEN
  BEGIN
    Writeln('This program needs MF-II keyboard to work properly');
    Halt;
  END;
  Cursor(Off);
  SetPAL(AltPAL);
  SetBlink(False);
  MkWin(11,1,59,2,$19,Single1,'');
  WriteBetween(11,69,2,$1E,'KEYBORD TEST '+Version+' by The GodFather');
  OpenWin(1,5,79,20,$5D,$5E,Double1,'MF-II Extended Keyboard');
  WriteBetween(1,80,25,$5B,' Press ESC 2 times to quit ');

  Special     := False;
  QuitCounter := 0;

  GetIntVec($09,OldInt09);
  SetIntVec($09,@NewKBDint);
  ShowKbd;
  REPEAT
    FOR Index := 1 TO 127 DO ShowKey(Keys[Index]);
  UNTIL QuitCounter = 2;
  SetIntVec($09,OldInt09);
  RmWin;
  RmWin;
  SetPal(OrgPal);
  Cursor(On);
  SetBlink(True);
END.